#include <bits/stdc++.h>
#define MAXM 1000003
#define MAXN 100002
using namespace std;
bool tramvai[MAXM];
int c[MAXM];
//           v   L
vector<pair<int,int> > edges[MAXN];
int dist[MAXN];
int distTram[MAXN];
bool usedL[MAXN];//      dist tramvai v
priority_queue<pair<pair<int,bool>, int> > pq;
int n;
int dijkstra()
{
    fill_n(dist, n+1, INT_MAX);
    pq.push({{0, 0}, 1});
    while (!pq.empty())
    {
        int curr = pq.top().second;
        int currDist = -pq.top().first.first;
        bool tram = pq.top().first.second;
        cerr << curr << " " << currDist << " " << tram << endl;
        pq.pop();
        if ( currDist > dist[curr] ) continue;
        if ( currDist == dist[curr] && tram ) continue;
        for (auto edge : edges[curr])
        {
            int next = edge.first;
            int linie = edge.second;
            int weight = (usedL[linie])? 0:c[linie];
            if ( currDist + weight < dist[next] )
            {
                usedL[linie] = true;
                dist[next] = currDist + weight;
                dist[next] += tramvai[linie];
                pq.push({ {-currDist - weight, tramvai[linie]}, next});
            }
        }
    }
    return dist[n];
}
int main( )
{
    int  m, k;
    cin >> n >> m >> k;
    for (int i=0; i<k; i++) cin >> tramvai[i];
    for (int i=0; i<k; i++) cin >> c[i];
    for (int i=0; i<m; i++)
    {
        int b, e, L;
        cin >> b >> e >> L;
        edges[b].push_back({e, L});
        edges[e].push_back({b, L});
    }
    cout << dijkstra() << " " << distTram[n] << endl;
}
/**
10 16 7
1 0 0 1 0 1 0
8 5 3 4 1 2 11
1 5 1
1 8 1
3 1 2
6 3 3
6 8 3
2 8 4
2 5 4
5 8 4
2 4 5
4 9 6
7 4 6
10 7 6
10 9 7
9 8 7
6 9 7
10 6 7
------------
15 2

*/
