#include<bits/stdc++.h>
#define endl "\n"
#define pii pair<int,int>
#define tg first
#define to second
using namespace std;

int brV, brReb, brR, maxr = 1000000001;

vector <pii> routes;
vector <bool> used;
vector <vector<pii>> V;
priority_queue <pii,
               vector<pii>,
               greater<pii>> pq;
vector <int> d;


void input()
{
    cin >> brV >> brReb >> brR;

    routes.resize(brR);
    V.resize(brV);

    for(int i=0; i<brR; i++)
    {
        cin >> routes[i].first;
    }
    for(int i=0; i<brR; i++)
    {
        cin >> routes[i].second;
    }
    int a, b, c;
    for(int i=0; i<brReb; i++)
    {
        cin >> a >> b >> c;
        V[a-1].push_back({b-1, routes[c-1].second});
        V[b-1].push_back({a-1, routes[c-1].second});
    }
}

void Algorithm_optimized(int s)
{
    d.resize(brV, 1000000001);
    d[s] = 0;
    used.resize(brV, false);
    pq.push({s,0});

    int i=0;
    while(used[brV-1] == false)
    {
        s = pq.top().tg;
        cout << s << endl;

        if(used[s])
        {
            pq.pop();
            continue;
        }
        used[s] = true;

        for(auto v : V[s])
        {
            if(d[v.tg] > d[s] + v.to && !used[v.tg])
            {
                d[v.tg] = d[s] + v.to;
            }
            pq.push({v.tg, d[v.tg]});
            if(v.tg == brV-1 && maxr > d[v.tg])maxr = d[v.tg];
        }
        pq.pop();

    }


}



int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(NULL);
    cout.tie(NULL);

    input();
    Algorithm_optimized(0);
    cout << maxr << " " << 0 << endl;
}
