#include <iostream>
#include <vector>
#include <string>
#include <cstring>
#include <algorithm>

using namespace std;

int n;

const int maxn = 20;
const int max_mask = (1 << maxn);

long long dp[maxn][max_mask];
bool bl[maxn][max_mask];

long long f(int pos, int mask)
{
    if (pos == 2 * n)
    {
        return 1;
    }

    if (bl[pos][mask])
    {
        return dp[pos][mask];
    }

    bl[pos][mask] = 1;

    long long res = 0;

    for (int i = 0; i < 2 * n; ++i)
    {
        if (i <= n - 1 && (mask & (1 << i)) == 0)
        {
            res += f(pos + 1, (mask | (1 << i)));
        }
        else if (i >= n && (mask & (1 << i)) == 0 && (mask & (1 << (i - n))) != 0)
        {
            res += f(pos + 1, (mask | (1 << i)));
        }
    }

    return dp[pos][mask] = res;
}

void fastIO()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
}

int main()
{
    //fastIO();

    cin >> n;

    cout << f(0, 0) << endl;

    return 0;
}
