#include <iostream>
#include <vector>
#include <string>
#include <cstring>
#include <stack>
#include <algorithm>

using namespace std;

int n;

void fastIO()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
}

int main()
{
    //fastIO();

    cin >> n;

    __int128 ans = 1;

    for (int i = 2 * n; i >= 2; i -= 2)
    {
        long long curr = (i * (i - 1)) / 2;
        ans *= curr;
    }

    stack<int> digs;

    while (ans != 0)
    {
        digs.push(ans % 10);
        ans /= 10;
    }

    while (!digs.empty())
    {
        cout << digs.top();
        digs.pop();
    }

    cout << endl;

    return 0;
}
