#include <iostream>

using namespace std;

const int maxn = 200005;

int n;

long long a[maxn];

long long p[maxn];
long long s[maxn];

void solve()
{
    long long t;
    cin >> t;

    if (t < a[1])
    {
        cout << -1 << "\n";
        return;
    }

    for (int i = 1; i <= n; ++i)
    {
        if (i * t - p[i] >= s[i + 1])
        {
            cout << i << "\n";
            break;
        }
    }
}

void fastIO()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
}

int main()
{
    fastIO();

    cin >> n;

    for (int i = 1; i <= n; ++i)
    {
        cin >> a[i];

        p[i] = p[i - 1] + a[i];
    }

    for (int i = n; i >= 1; --i)
    {
        s[i] = s[i + 1] + a[i];
    }

    int q;
    cin >> q;

    while (q--)
    {
        solve();
    }

    return 0;
}
