#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

const int maxn = 200005;

int n;

long long a[maxn];
vector<pair<long long, int>> v;

long long sum = 0;

bool has[maxn];

bool check(int cranes, long long t)
{
    long long sum = 0;
    long long sum2 = 0;

    for (int i = 1; i <= n; ++i)
    {
        has[i] = 0;
    }

    for (int i = 0; i < cranes; ++i)
    {
        has[v[i].second] = 1;
    }

    int cr = 0;

    for (int i = 1; i <= n; ++i)
    {
        if (!has[i])
        {
            sum2 += a[i];
        }
        else
        {
            ++cr;
            sum += a[i];
        }

        if (cr * t - sum < sum2)
        {
            return false;
        }
    }

    return true;
}

void solve()
{
    long long t;
    cin >> t;

    if (t < a[1])
    {
        cout << -1 << "\n";
        return;
    }

    for (int i = (sum % t == 0 ? sum / t : sum / t + 1); i <= n; ++i)
    {
        if (check(i, t) == true)
        {
            cout << i << "\n";
            return;
        }
    }

    cout << -1 << "\n";
}

bool cmp(pair<long long, int> x, pair<long long, int> y)
{
    if (x.first != y.first)
    {
        return x.first > y.first;
    }

    return x.second <= y.second;
}

void fastIO()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
}

int main()
{
    fastIO();

    cin >> n;

    for (int i = 1; i <= n; ++i)
    {
        cin >> a[i];
        sum += a[i];
        v.push_back(make_pair(a[i], i));
    }

    sort(v.begin(), v.end(), cmp);

    int q;
    cin >> q;

    while (q--)
    {
        solve();
    }

    return 0;
}
