#include<bits/stdc++.h>
using namespace std;

#define endl "\n"

const long long MAX_N = 1e5 + 10;
const long long MAX_M = 1e6 + 10;

int n, m, k;
vector<pair<int, int>> susediNaSpirka[MAX_N];
vector<int> spirkiVLiniq[MAX_M];
vector<int> linesOfX[MAX_N];

int priceOfLine[MAX_M];
bool isTram[MAX_M];


vector<int> susediNaLiniq[MAX_M];
vector<int> susediNa[MAX_M];

bool checked[MAX_M];
int price[MAX_M];
int trams[MAX_M];
const long long INF = 999999999;

void solve (int start) {
    priority_queue<pair<pair<int, int>, int>> pq;
    pq.push({{0, 0}, start});
    for (int i = 1; i <= k; i ++) {
        checked[i] = false;
        price[i] = INF;
        trams[i] = INF;
    }

    price[start] = priceOfLine[start];
    trams[start] = isTram[start];
    while(!pq.empty()){
        int current = pq.top().second;
        pq.pop();
        if (checked[current]) continue;
        //cout << "Starting " << current << " with price " << price[current] << endl;
        checked[current] = true;
        for (int i = 0; i < susediNa[current].size(); i++) {
            if (checked[susediNa[current][i]]){
                continue;
            }
            if (price[susediNa[current][i]] > price[current] + priceOfLine[susediNa[current][i]]) {
                price[susediNa[current][i]] = price[current] + priceOfLine[susediNa[current][i]];
                trams[susediNa[current][i]] = trams[current];
                if (isTram[susediNa[current][i]]) trams[susediNa[current][i]] ++;
            }else if (price[susediNa[current][i]] == price[current] + priceOfLine[susediNa[current][i]]) {
                int newTrans = trams[current];
                if (isTram[susediNa[current][i]]) {
                    newTrans ++;
                }
                trams[susediNa[current][i]] = min (trams[susediNa[current][i]], newTrans);
            }
          //  cout << "\tAdding " << susediNa[current][i] << " with p = "<<price[susediNa[current][i]] << " " <<trams[susediNa[current][i]] << endl;
            pq.push({{-price[susediNa[current][i]], -trams[susediNa[current][i]]}, susediNa[current][i]});
        }
    }
}

int main () {
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);

    cin >> n >> m >> k;



    for (int i = 1; i <= k; i ++) {
        int a; cin >> a;
        if (a == 1) isTram[i] = true;
        if (a == 0) isTram[i] = false;
    }

    for (int i = 1; i <= k; i ++) {
        cin >> priceOfLine[i];
    }

    for (int i = 0; i < m; i ++) {
        int a, b, c;
        cin >> a >> b >> c;
        susediNaSpirka[a].push_back({b, c});
        susediNaSpirka[b].push_back({a, c});
        spirkiVLiniq[c].push_back(a);
        spirkiVLiniq[c].push_back(b);
        linesOfX[a].push_back(c);
        linesOfX[b].push_back(c);
    }

    for (int i = 1; i <= k; i ++) {
        for (int j = 0; j < spirkiVLiniq[i].size(); j ++) {
            int currentInd = spirkiVLiniq[i][j];
            for (int l = 0; l < linesOfX[currentInd].size(); l ++) {
                if (linesOfX[currentInd][l] != i) {
                    susediNaLiniq[i].push_back(linesOfX[currentInd][l]);
                    susediNaLiniq[linesOfX[currentInd][l]].push_back(i);
                }
            }
            for (int s = 0; s < susediNaSpirka[currentInd].size(); s ++) {
                    if (susediNaSpirka[currentInd][s].second != i) {
                        continue;
                    }
                    for (int l = 0; l < linesOfX[susediNaSpirka[currentInd][s].first].size(); l ++) {
                        if (linesOfX[susediNaSpirka[currentInd][s].first][l] != i) {

                            susediNaLiniq[i].push_back(linesOfX[susediNaSpirka[currentInd][s].first][l]);
                            susediNaLiniq[linesOfX[susediNaSpirka[currentInd][s].first][l]].push_back(i);
                        }
                    }
            }
        }
    }


    for (int i = 1; i <= k; i ++) {
        sort(susediNaLiniq[i].begin(), susediNaLiniq[i].end());
        for (int j = 0; j < susediNaLiniq[i].size(); j ++) {
            if (j == susediNaLiniq[i].size() - 1 || susediNaLiniq[i][j] != susediNaLiniq[i][j + 1]) {
                susediNa[i].push_back(susediNaLiniq[i][j]);
            }
        }
    }
/*for (int i = 1; i <= k; i ++) {
        cout << i << ": ";
        for (int j = 0; j < susediNa[i].size(); j ++) {
            cout << susediNa[i][j] << ", ";
        }
        cout << endl;
    }*/
    int ans1 = INF, ans2 = INF;
    for (int i = 0; i < linesOfX[1].size(); i++) {
        //cout << linesOfX[1][i] << endl;
        solve(linesOfX[1][i]);
        /*for (int j = 1; j <= k; j ++) {
            cout << price[j] << " ";
        }
        cout << endl;
        for (int j = 1; j <= k; j ++) {
            cout << trams[j] << " ";
        }
        cout << endl;
        */
        for (int j = 0; j < linesOfX[n].size(); j ++) {
        //    cout << "\t"<< linesOfX[n][j]<< endl;
            if (ans1 > price[linesOfX[n][j]]) {
                ans1 = price[linesOfX[n][j]];
                ans2 = trams[linesOfX[n][j]];
            }else if (ans1 == price[linesOfX[n][j]]) {
                ans2 = min (ans2, trams[linesOfX[n][j]]);
            }
        }
    }

    cout << ans1 << " " << ans2 << endl;

    return 0;
}
