#include<bits/stdc++.h>
#define endl "\n"
#define inf 2147483647
using namespace std;
int n,m,k;
bool tram[1000010];
int price[1000010];
vector<int> g[1000010];
vector< pair<int,int> > gr[1000010];
vector<int> lines[100010];
unordered_map<long long,bool> exists;
pair<int,int> dist[1000010];
int dist2[1000010];
void dijkstra(int s){
    for(int i=0;i<=k+1;i++){
        dist[i]={inf,inf};
    }
    priority_queue< pair<pair<int,int>,int> > pq;
    pq.push({{0,0},s});
    dist[s]={0,0};
    while(!pq.empty()){
        int pr=-pq.top().first.first;
        int tr=-pq.top().first.second;
        int u=pq.top().second;
        pq.pop();
        for(auto v:g[u]){
            if(pr+price[v]<dist[v].first){
                dist[v]={pr+price[v],tr+tram[v]};
                pq.push({{-dist[v].first,-dist[v].second},v});
            }
            else if(pr+price[v]==dist[v].first && tr+tram[v]<dist[v].second){
                dist[v]={pr+price[v],tr+tram[v]};
                pq.push({{-dist[v].first,-dist[v].second},v});
            }
        }
    }
}

void dijkstra2(int s){
    for(int i=0;i<=k+1;i++){
        dist2[i]=inf;
    }
    priority_queue< pair<int,int> > pq;
    pq.push({0,s});
    dist2[s]=0;
    while(!pq.empty()){
        int d=-pq.top().first;
        int u=pq.top().second;
        pq.pop();
        for(auto p:gr[u]){
            int v=p.first;
            int w=p.second;
            if(d+w<dist2[v]){
                dist2[v]=d+w;
                pq.push({-dist2[v],v});
            }
        }
    }
}
int main(){
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    cin>>n>>m>>k;
    bool asdf=false;
    for(int i=0;i<k;i++){
        cin>>tram[i];
        asdf|=tram[i];
    }
    for(int i=0;i<k;i++){
        cin>>price[i];
    }
    if(!asdf && k==m){
        for(int i=0;i<m;i++){
            int u,v,t;
            cin>>u>>v>>t;
            u--;
            v--;
            t--;
            gr[u].push_back({v,price[t]});
            gr[v].push_back({u,price[t]});
        }
        dijkstra2(0);
        cout<<dist2[n-1]<<" "<<0;
        return 0;
    }





    for(int i=0;i<m;i++){
        int u,v,t;
        cin>>u>>v>>t;
        u--;
        v--;
        t--;
        lines[u].push_back(t);
        lines[v].push_back(t);
    }
    for(int u=0;u<n;u++){
        for(auto t1:lines[u]){
            for(auto t2:lines[u]){
                if(t1==t2) continue;
                if(!exists[t1*1000010+t2]){
                    g[t1].push_back(t2);
                    exists[t1*1000010+t2]=true;
                }
            }
        }
    }
    /*for(int i=0;i<k;i++){
        cout<<i+1<<":  ";
        for(int j=0;j<g[i].size();j++){
            cout<<g[i][j]+1<<" ";
        }
        cout<<endl;
    }*/
    for(auto t:lines[0]){
        g[k].push_back(t);
    }
    for(auto t:lines[n-1]){
        g[t].push_back(k+1);
    }
    dijkstra(k);
    cout<<dist[k+1].first<<" "<<dist[k+1].second;
    return 0;
}
