#include<bits/stdc++.h>
#define endl "\n"
#define inf 2147483647
using namespace std;
unsigned long long n,m,k;
bool tram[1000010];
unsigned long long price[1000010];
vector<unsigned long long> g[1000010];
vector< pair<unsigned long long,unsigned long long> > gr[1000010];
vector<unsigned long long> lines[1000010];
unordered_map<unsigned long long,bool> exists;
pair<unsigned long long,unsigned long long> dist[1000010];
unsigned long long dist2[1000010];
void dijkstra(unsigned long long s){
    for(unsigned long long i=0;i<=k+1;i++){
        dist[i]={inf,inf};
    }
    priority_queue< pair<pair<unsigned long long,unsigned long long>,unsigned long long> > pq;
    pq.push({{0,0},s});
    dist[s]={0,0};
    while(!pq.empty()){
        unsigned long long pr=-pq.top().first.first;
        unsigned long long tr=-pq.top().first.second;
        unsigned long long u=pq.top().second;
        pq.pop();
        for(auto v:g[u]){
            if(pr+price[v]<dist[v].first){
                dist[v]={pr+price[v],tr+tram[v]};
                pq.push({{-dist[v].first,-dist[v].second},v});
            }
            else if(pr+price[v]==dist[v].first && tr+tram[v]<dist[v].second){
                dist[v]={pr+price[v],tr+tram[v]};
                pq.push({{-dist[v].first,-dist[v].second},v});
            }
        }
    }
}

void dijkstra2(unsigned long long s){
    for(unsigned long long i=0;i<=n+1;i++){
        dist2[i]=inf;
    }
    priority_queue< pair<unsigned long long,unsigned long long> > pq;
    pq.push({0,s});
    dist2[s]=0;
    while(!pq.empty()){
        unsigned long long d=-pq.top().first;
        unsigned long long u=pq.top().second;
        pq.pop();
        for(auto p:gr[u]){
            unsigned long long v=p.first;
            unsigned long long w=p.second;
            if(d+w<dist2[v]){
                dist2[v]=d+w;
                pq.push({-dist2[v],v});
            }
        }
    }
}

void dijkstra3(unsigned long long s){
    for(unsigned long long i=0;i<=n+1;i++){
        dist2[i]=inf;
    }
    priority_queue< pair<unsigned long long,pair<unsigned long long,unsigned long long> > > pq;
    pq.push({0,{s,-1}});
    dist2[s]=0;
    while(!pq.empty()){
        unsigned long long d=-pq.top().first;
        unsigned long long u=pq.top().second.first;
        unsigned long long t1=pq.top().second.second;
        pq.pop();
        for(auto p:gr[u]){
            unsigned long long v=p.first;
            unsigned long long t2=p.second;
            unsigned long long w=price[t2];
            if(t1==t2) w=0;
            if(d+w<dist2[v]){
                dist2[v]=d+w;
                pq.push({-dist2[v],{v,t2}});
            }
        }
    }
}

int main(){
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    cin>>n>>m>>k;
    bool asdf=false;
    for(unsigned long long i=0;i<k;i++){
        cin>>tram[i];
        asdf|=tram[i];
    }
    for(unsigned long long i=0;i<k;i++){
        cin>>price[i];
    }
    if(!asdf && k==m){
        for(unsigned long long i=0;i<m;i++){
            unsigned long long u,v,t;
            cin>>u>>v>>t;
            u--;
            v--;
            t--;
            gr[u].push_back({v,price[t]});
            gr[v].push_back({u,price[t]});
        }
        dijkstra2(0);
        cout<<dist2[n-1]<<" "<<0;
        return 0;
    }




    if(k<=1000 && m<=1000){
        for(unsigned long long i=0;i<m;i++){
            unsigned long long u,v,t;
            cin>>u>>v>>t;
            u--;
            v--;
            t--;
            lines[u].push_back(t);
            lines[v].push_back(t);
        }
        for(unsigned long long u=0;u<n;u++){
            for(auto t1:lines[u]){
                for(auto t2:lines[u]){
                    if(t1==t2) continue;
                    if(!exists[t1*1000010+t2]){
                        g[t1].push_back(t2);
                        exists[t1*1000010+t2]=true;
                    }
                }
            }
        }
        for(auto t:lines[0]){
            g[k].push_back(t);
        }
        for(auto t:lines[n-1]){
            g[t].push_back(k+1);
        }
        dijkstra(k);
        cout<<dist[k+1].first<<" "<<dist[k+1].second;
        return 0;
    }




    for(unsigned long long i=0;i<m;i++){
        unsigned long long u,v,t;
        cin>>u>>v>>t;
        u--;
        v--;
        t--;
        gr[u].push_back({v,t});
        gr[v].push_back({u,t});
    }
    dijkstra3(0);
    cout<<dist2[n-1]<<" "<<0;
    return 0;
}
