#include <bits/stdc++.h>
using namespace std;

const int MAX_N=2*1e5+1;
int N, Q;
int v[MAX_N];

bool is_good(const int& value, int& t)
{
    long long x=1;
    long long counter=0;
    long long sum=0;

    if(t*value<sum)
    {
        return false;
    }

    for(int i=1; i<=N; i++)
    {
        sum+=v[i];

        while(x<i && sum>x*t)
        {
            x++;

            if(x>value)
            {
                return false;
            }
        }

        if(sum>x*t)
        {
            return false;
        }
    }

    return true;
}

int bs(int& t)
{
    int l=1, r=N;
    int ans=-1;
    int m;

    while(l<=r)
    {
        m=(l+r)/2;

        if(is_good(m, t))
        {
            ans=m;
            r=m-1;
        }
        else
        {
            l=m+1;
        }
    }

    return ans;
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    cin >> N;

    for(int i=1; i<=N; i++)
    {
        cin >> v[i];
    }

    cin >> Q;

    int t;

    while(Q--)
    {
        cin >> t;

        if(t<v[0])
        {
            cout << -1 << '\n';
        }
        else
        {
            cout << bs(t) << '\n';
        }
    }

    return 0;
}

