#include <bits/stdc++.h>
using namespace std;

const int MAX_N=2*1e5+1;
int N, Q;
int v[MAX_N];
pair<long long, int> quests[MAX_N];
int ans[MAX_N];

bool is_good(const long long& value, long long& t)
{
    long long x=1;
    long long counter=0;
    long long sum=0;

    if(t*value<sum)
    {
        return false;
    }

    for(long long i=1; i<=N; i++)
    {
        sum+=v[i];

        if(sum>x*t)
        {
            x=sum/t;

            if(sum%t!=0)
            {
                x++;
            }

            if(x>i)
            {
                return false;
            }
        }
    }

    if(x>value)
    {
        return false;
    }

    return true;
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    cin >> N;

    for(int i=1; i<=N; i++)
    {
        cin >> v[i];
    }

    cin >> Q;

    for(int i=0; i<Q; i++)
    {
        cin >> quests[i].first;
        quests[i].second=i;
    }

    sort(quests, quests+Q);
    reverse(quests, quests+Q);

    long long value=1;

    for(int i=0; i<Q; i++)
    {
        if(value!=-1)
        {
            while(!is_good(value, quests[i].first) && value<=N)
            {
                value++;
            }
        }

        if(value>N)
        {
            value=-1;
        }

        ans[quests[i].second]=value;
    }

    for(int i=0; i<Q; i++)
    {
        cout << ans[i] << '\n';
    }

    return 0;
}
