#include <bits/stdc++.h>
using namespace std;

const int MAX_N=1e5+1, MAX_M=1e6+1, MAX_K=1e6+1;
const long long INF=1e18;
int N, M, K;
int type[MAX_K];
int price[MAX_K];
vector<pair<int, int>> edges[MAX_M];
pair<long long, int> dist[MAX_N];
pair<int, int> parent[MAX_N];

void dejikstra()
{
    priority_queue<tuple<long long, int, int>> pq;
    pq.push({0, 0, 1});
    dist[1]= {0, 0};

    while(!pq.empty())
    {
        tuple<long long, int, int> u=pq.top();
        pq.pop();

        for(auto& v:edges[get<2>(u)])
        {
            long long p=price[v.second]-get<0>(u);
            int tram=type[v.second]-get<1>(u);

            pair<int, int> i={get<2>(u), v.second};

            while(i.first!=1)
            {
                i=parent[i.first];

                if(i.second==v.second)
                {
                    p-=price[v.second];
                    tram-=type[v.second];
                    break;
                }
            }

            if(dist[v.first].first>p || dist[v.first].first==p && dist[v.first].second>tram)
            {
                ///cout << v.first << " -> " << p << " " << tram << '\n';
                parent[v.first]= {get<2>(u), v.second};
                dist[v.first]= {p, tram};
                pq.push({-p, -tram, v.first});
            }
        }
    }
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    cin >> N >> M >> K;

    for(int i=1; i<=K; i++)
    {
        cin >> type[i];
    }

    for(int i=1; i<=K; i++)
    {
        cin >> price[i];
    }

    for(int i=1; i<=M; i++)
    {
        int u, v, t;
        cin >> u >> v >> t;
        edges[u].push_back({v, t});
        edges[v].push_back({u, t});
    }

    for(int i=1; i<=N; i++)
    {
        dist[i].first=INF;
    }

    dejikstra();

    cout << dist[N].first << " " << dist[N].second << '\n';
    return 0;
}

