#include <bits/stdc++.h>
using namespace std;

const int MAX_N=1e5+1, MAX_M=1e6+1, MAX_K=1e6+1;
const long long INF=1e18;
int N, M, K;
int type[MAX_K];
int price[MAX_K];
vector<pair<int, int>> edges[MAX_M];
map<pair<vector<int>, long long>, long long> dist;

void dfs(int u, vector<int> vect)
{
    for(auto& v:edges[u])
    {
        if(v.first==1)
        {
            continue;
        }

        long long p=dist[{vect, u}];

        if(vect.empty() || vect[0]!=v.second || vect.find(v.second)==vect.end())
        {
            p+=price[v.second];
        }

        vect.push_back(v.second);

        if(dist[{vect, v.first}]>p || dist[{vect, v.first}]==0)
        {
            dist[{vect, v.first}]=p;
            dfs(v.first, vect);
        }

        vect.pop_back();
    }
}


int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    cin >> N >> M >> K;

    for(int i=1; i<=K; i++)
    {
        cin >> type[i];
    }

    for(int i=1; i<=K; i++)
    {
        cin >> price[i];
    }

    for(int i=1; i<=M; i++)
    {
        int u, v, t;
        cin >> u >> v >> t;
        edges[u].push_back({v, t});
        edges[v].push_back({u, t});
    }

    dfs(1);
    cout << dist[N] << " " << 0;
    return 0;
}
