#include <bits/stdc++.h>

using namespace std;

typedef long long ll;

string pre[27];

string multiply(string &a, ll b)
{
    if (b == 0)
    {
        return "0";
    }

    string res = "";
    ll carry = 0;

    for (int i = a.size() - 1; i >= 0; i--)
    {
        if (i > 0)
        {
            ll digit = (a[i] - '0') * b + carry;

            carry = digit / 10;
            digit %= 10;

            res += digit + '0';
        }
        else
        {
            ll digit = (a[i] - '0') * b + carry;

            while (digit)
            {
                ll add = digit % 10;

                res += add + '0';
                digit /= 10;
            }
        }
    }

    reverse(res.begin(), res.end());

    return res;
}

int main()
{
    ll n, pro = 6, diff = 9;

    cin >> n;

    pre[1] = "1";

    for (ll i = 2; i <= n; i++)
    {
        pre[i] = multiply(pre[i - 1], pro);
        pro += diff;
        diff += 4;
    }

    cout << pre[n] << endl;

    return 0;
}
