#include <iostream>
#include <vector>
#include <algorithm>
#include <queue>
#include <tuple>
using namespace std;
#define ll long long

class st {
    public:
    st();
    ~st();

    ll pr;
    ll pos;
    ll tramvai_cnt;
    vector<ll> paidforln;
};

st::st () {};
st::~st() {};

queue<st> q;
vector<ll> r[1000001];
bool tramvai[1000001];
ll price[1000001];
pair<ll, ll> pr_and_tr[1000001];

vector<ll> lr[1000001];

bool bin_search_bool(vector<ll> num, ll a, ll n) {
    ll l = 0, r = n - 1;
    ll m;

    if (n == 0) {
        return 0;
    }

    if (a > num[n - 1]) {
        return n;
    }
    if (a < num[0]) {
        return 0;
    }

    while (r >= l) {
        m = (l + r) / 2;
        if (num[m] > a) { ///1 2 [3] (2)
            r = m - 1;
            continue;
        }
        if (num[m + 1] < a) { ///1 [2] (4) 3
            l = m + 1;
            continue;
        }
        if (num[m + 1] == a || a == num[m]) { ///1 [2] (3) 4
            return 1;
        }
    }
   return 0;
}

void bfs (ll n) {
    while(!q.empty()) {
        st za = q.front();
        q.pop();

        if (pr_and_tr[za.pos].first == 0 || pr_and_tr[za.pos] < make_pair(za.pr, za.tramvai_cnt)) {
            pr_and_tr[za.pos] = make_pair(za.pr, za.tramvai_cnt);
        } else {
            continue;
        }
        for (ll i = 0; i < lr[za.pos].size(); i++) {
            for (ll j = 0; j < r[lr[za.pos][i]].size(); j++) {
                st temp;
                temp.paidforln = za.paidforln;
                temp.pr = za.pr;
                temp.pos = r[lr[za.pos][i]][j];
                if (!bin_search_bool(za.paidforln, lr[za.pos][i], za.paidforln.size())){
                    temp.pr += price[lr[za.pos][i]];
                    temp.paidforln.push_back(lr[za.pos][i]);
                    sort(temp.paidforln.begin(), temp.paidforln.end());
                }
                temp.tramvai_cnt = za.tramvai_cnt + tramvai[lr[za.pos][i]];
                q.push(temp);
            }
        }
    }
}

int main () {
    ios_base::sync_with_stdio(0);
    cin.tie(0);

    ll n, m, k;
    cin >> n >> m >> k;
    for (ll i = 0; i < k; i++) {
        cin >> tramvai[i];
    }
    for (ll i = 0; i < k; i++) {
        cin >> price[i];
    }

    for (ll i = 0; i < m; i++) {
        ll a, b, c;
        cin >> a >> b >> c;
        a--;
        b--;
        c--;
        lr[a].push_back(c);
        lr[b].push_back(c);
        r[c].push_back(a);
        r[c].push_back(b);
    }
    st fs;
    fs.pr = 0;
    fs.pos = 0;
    fs.tramvai_cnt = 0;
    fs.paidforln = vector<ll>();
//    pr_and_tr[0] = make_pair(1, 1);
    q.push(fs);
    bfs(n);

    cout << pr_and_tr[n - 1].first << " " << pr_and_tr[n - 1].second;
}
