#include <bits/stdc++.h>
#define endl '\n'

using namespace std;

const int maxn = 64;
long long comb[maxn][maxn], fact[maxn], dp[maxn][maxn], n;

void pascal(){
    for(int i = 0;i < maxn;i++)
        comb[i][0] = 1;
    for(int i = 1;i < maxn;i++)
        for(int j = 1;j < maxn;j++)
            comb[i][j] = comb[i - 1][j] + comb[i - 1][j - 1];
    fact[0] = 1;
    for(int i = 1;i < maxn;i++)
        fact[i] = fact[i - 1] * i;
}

void solve(){
    dp[0][0] = 1;
    for(int i = 1;i <= n;i++){
        for(int j = 0;j <= i;j++){
            for(int k = 0;k <= j;k++){
                dp[i][j] += fact[k] * comb[i - j + k][k] * dp[i - 1][j - k];
            }
        }
    }
    cout << dp[n][n] * fact[n] << endl;
}
int main(){
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    cin >> n;
    pascal();
    solve();
    return 0;
}
