#include <bits/stdc++.h>
#define endl '\n'

using namespace std;

const int maxn = 64;
const long long mod = 1e9 + 7;
string comb[maxn][maxn], fact[maxn];
string dp[maxn][maxn];
int n;

string f(string a, int len){
    int i = a.size();
    for(;i < len;i++)
        a = '0' + a;
    return a;
}

string add(string a, string b){
    string res = "";
    int len = max(a.size(), b.size());
    a = f(a, len); b = f(b, len);
    int pren = 0;
    for(int i = len - 1;i >= 0;i--){
        int dig = a[i] + b[i] - 96 + pren;
        pren = dig / 10;
        dig %= 10;
        res = (char)(dig + '0') + res;
    }
    if(pren) res = (char)(pren + '0') + res;
    return res;
}

string mult_c(string s, int c){
    string res = "";
    int pren = 0;
    for(int i = s.size() - 1;i >= 0;i--){
        int dig = s[i] - '0'; dig *= c; dig += pren;
        pren = dig / 10;
        dig %= 10;
        res = (char)(dig + '0') + res;
    }
    if(pren) res = (char)(pren + '0') + res;
    return res;
}

string mult(string a, string b){
    string m[10];
    for(int i = 0;i < 10;i++)
        m[i] = mult_c(a, i);
    int len = b.size(), cnt = 0;
    string res = "0";
    for(int i = len - 1;i >= 0;i--){
        string p = m[b[i] - '0'];
        for(int j = 0;j < cnt;j++)
            p += '0';
        res = add(res, p);
        cnt++;
    }
    return res;
}

string conv(int x){
    string res = "";
    do{
        res = (char)((x % 10) + '0') + res;
        x /= 10;
    }while(x);
    return res;
}
void pascal(){
    for(int i = 0;i < maxn;i++)
        comb[i][0] = "1";
    for(int i = 1;i < maxn;i++)
        for(int j = 1;j <= i;j++)
            comb[i][j] = add(comb[i - 1][j], comb[i - 1][j - 1]);
    fact[0] = "1";
    for(int i = 1;i < maxn;i++)
        fact[i] = mult(fact[i - 1], conv(i));
}

void solve(){
    dp[0][0] = "1";
    for(int i = 1;i <= n;i++)
        for(int j = 1;j <= n;j++)
            dp[i][j] = "0";
    for(int i = 1;i <= n;i++){
        for(int j = 0;j <= i;j++){
            for(int k = 0;k <= j;k++){
                dp[i][j] = add(dp[i][j], mult(mult(fact[k], comb[i - j + k][k]), dp[i - 1][j - k]));
            }
        }
    }
    cout << mult(dp[n][n], fact[n]) << endl;
}
int main(){
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    cin >> n;
    pascal();
    solve();
    return 0;
}
