#include <bits/stdc++.h>
#define endl '\n'

using namespace std;

const int maxn = 1e5 + 10;
int n, m, k, type[maxn], c[maxn], u[maxn], v[maxn], t[maxn];

struct edge{
    int x, dist;

    bool operator<(const edge &e) const{
        return dist > e.dist;
    }
};
vector<edge> g[maxn];
priority_queue<edge> q;
unsigned int d[maxn];
int p[maxn], used[maxn];
long long ans = 1e17, tr;

void read(){
    cin >> n >> m >> k;
    for(int i = 1;i <= k;i++){
        cin >> type[i];
    }
    for(int i = 1;i <= k;i++){
        cin >> c[i];
    }
    for(int i = 1;i <= m;i++){
        cin >> u[i] >> v[i] >> t[i];
        g[u[i]].push_back({v[i], t[i]});
        g[v[i]].push_back({u[i], t[i]});
    }
}

void dijkstra(){
    memset(d, -1, sizeof(d));
    d[1] = 0;
    q.push({1, 0});
    while(!q.empty()){
        edge e = q.top();
        if(!used[e.x]){
            used[e.x] = 1;
            for(edge nb : g[e.x]){
                if(d[nb.x] > nb.dist + e.dist){
                    nb.dist += e.dist;
                    d[nb.x] = nb.dist;
                    q.push(nb);
                }
            }
        }
    }
    cout << d[n] << endl;
}

int main(){
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    read();
    dijkstra();
    cout << d[n] << " " << 0 << endl;
    return 0;
}
