#include <bits/stdc++.h>
#define endl '\n'

using namespace std;

const int maxn = 1e6 + 10;
int n, m, k, type[maxn], c[maxn], u[maxn], v[maxn], t[maxn];

struct edge{
    int x, dist;

    bool operator<(const edge &e) const{
        return dist > e.dist;
    }
};
vector<edge> g[maxn];
int idx[maxn], used[maxn], gen[maxn];
long long ans;


bool cmp(int a, int b){
    return c[a] > c[b];
}

void read(){
    cin >> n >> m >> k;
    for(int i = 1;i <= k;i++){
        cin >> type[i];
    }
    for(int i = 1;i <= k;i++){
        cin >> c[i];
        ans += c[i];
        idx[i] = i;
    }
    for(int i = 1;i <= m;i++){
        cin >> u[i] >> v[i] >> t[i];
        g[u[i]].push_back({v[i], t[i]});
        g[v[i]].push_back({u[i], t[i]});

    }
    sort(idx + 1, idx + k + 1, cmp);
}

void dfs(int ver){
    used[ver] = 1;
    for(edge nb : g[ver]){
        if(!used[nb.x] && !gen[nb.dist]){
            dfs(nb.x);
        }
    }
}
void solve(){
    for(int i = 1;i <= k;i++){
        memset(used, 0, sizeof(used));
        gen[idx[i]] = 1;
        dfs(1);
        if(!used[n]) break;
        ans -= c[idx[i]];
    }
    cout << ans << " " << 0 << endl;
}
int main(){
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    read();
    solve();
    return 0;
}
