#include <bits/stdc++.h>

using namespace std;

struct edge
{
    int ver,dist,num;
    edge(){};
    edge(int vi, int di, int ni)
    {
        ver = vi;
        dist = di;
        num = ni;
    }
    bool operator<(const edge&ed) const
    {
        return dist>ed.dist;
    }
};

const int maxn = 1e6+5;

int n,m,k;
int t[maxn],c[maxn];
//int mat[maxn][maxn];
unsigned long long d[maxn],inf=-1;
int last[maxn];
vector<edge>v[maxn];
vector<int>pom[maxn];

void read()
{
    cin >> n >> m >> k;
    for(int i=1;i<=k;i++) cin >> t[i];
    for(int i=1;i<=k;i++) cin >> c[i];
    int x,y,z;
    for(int i=1;i<=m;i++)
    {
        cin >> x >> y >> z;
        /*mat[z][x] = 1;
        mat[z][y] = 1;*/
        v[x].push_back({y,c[z],z});
        v[y].push_back({x,c[z],z});
    }
    /*for(int i=1;i<=k;i++)
    {
        for(int j=1;j<=n;j++)
        {
            if(mat[i][j]) pom[i].push_back(j);
        }
    }
    int sz,ch1,ch2;
    for(int i=1;i<=k;i++)
    {
        sz = pom[i].size();
        for(int j=0;j<sz;j++)
        {
            for(int j2=j+1;j2<sz;j2++)
            {
                ch1 = pom[i][j];
                ch2 = pom[i][j2];
                v[ch1].push_back({ch2,c[i]});
                v[ch2].push_back({ch1,c[i]});
            }
        }
    }*/
}

/*void BFS(int beg)
{
    used[beg] = 1;
    queue<int>q;
    q.push(beg);
    int w,nb,sz;
    while(!q.empty())
    {
        w = q.front();
        q.pop();
        sz = v[w].size();
        for(int i=0;i<sz;i++)
        {
            nb = v[w][i];
            if(!used[nb])
            {
                used[nb] = used[w] + 1;
                q.push(nb);
            }
        }
    }
}*/

void dijkstra(int beg)
{
    memset(d,-1,sizeof(d));
    priority_queue<edge>q;
    d[beg] = 0;
    last[beg] = 0;
    q.push({beg,0,0});
    int sz;
    edge e,nb;
    while(!q.empty())
    {
        e = q.top();
        q.pop();
        if(e.dist<=d[e.ver])
        {
            sz = v[e.ver].size();
            for(int i=0;i<sz;i++)
            {
                nb = v[e.ver][i];
                if(nb.num==e.num) nb.dist = 0;
                if(e.dist+nb.dist<d[nb.ver])
                {
                    nb.dist += e.dist;
                    d[nb.ver] = nb.dist;
                    q.push(nb);
                }
            }
        }
    }
}


void solve()
{
    dijkstra(1);
    cout << d[n] << " " << 0 << endl;
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    read();
    solve();
    return 0;
}
