#include <bits/stdc++.h>

using namespace std;

struct edge
{
    int ver,dist,num,brtt;
    edge(){};
    edge(int vi, int di, int ni, int bri)
    {
        ver = vi;
        dist = di;
        num = ni;
        brtt = 0;
    }
    bool operator<(const edge&ed) const
    {
        return dist>ed.dist;
    }
};

const int maxn = 1e3+5;

int n,m,k;
int t[maxn],c[maxn];
int mat[maxn][maxn];
unsigned long long d[maxn][maxn],inf=-1;
vector<edge>v[maxn];
vector<int>pom[maxn];

void read()
{
    cin >> n >> m >> k;
    for(int i=1;i<=k;i++) cin >> t[i];
    for(int i=1;i<=k;i++) cin >> c[i];
    int x,y,z;
    for(int i=1;i<=m;i++)
    {
        cin >> x >> y >> z;
        mat[z][x] = 1;
        mat[z][y] = 1;
    }
    for(int i=1;i<=k;i++)
    {
        for(int j=1;j<=n;j++)
        {
            if(mat[i][j]) pom[i].push_back(j);
        }
    }
    int sz,ch1,ch2;
    for(int i=1;i<=k;i++)
    {
        sz = pom[i].size();
        for(int j=0;j<sz;j++)
        {
            for(int j2=j+1;j2<sz;j2++)
            {
                ch1 = pom[i][j];
                ch2 = pom[i][j2];
                v[ch1].push_back({ch2,c[i],i,0});
                v[ch2].push_back({ch1,c[i],i,0});
            }
        }
    }
}

/*void BFS(int beg)
{
    used[beg] = 1;
    queue<int>q;
    q.push(beg);
    int w,nb,sz;
    while(!q.empty())
    {
        w = q.front();
        q.pop();
        sz = v[w].size();
        for(int i=0;i<sz;i++)
        {
            nb = v[w][i];
            if(!used[nb])
            {
                used[nb] = used[w] + 1;
                q.push(nb);
            }
        }
    }
}*/

void dijkstra(int beg)
{
    memset(d,-1,sizeof(d));
    priority_queue<edge>q;
    d[beg][0] = 0;
    q.push({beg,0,0,0});
    int sz;
    edge e,nb;
    while(!q.empty())
    {
        e = q.top();
        q.pop();
        int j = e.brtt;
        if(e.dist<=d[e.ver][j])
        {
            sz = v[e.ver].size();
            for(int i=0;i<sz;i++)
            {
                nb = v[e.ver][i];
                int idx = j + t[nb.num];
                if(e.dist+nb.dist<d[nb.ver][idx])
                {
                    nb.dist += e.dist;
                    d[nb.ver][idx] = nb.dist;
                    nb.brtt = idx;
                    q.push(nb);
                }
            }
        }
        j--;
        if(e.dist<=d[e.ver][j])
        {
            sz = v[e.ver].size();
            for(int i=0;i<sz;i++)
            {
                nb = v[e.ver][i];
                int idx = j + t[nb.num];
                if(e.dist+nb.dist<d[nb.ver][idx])
                {
                    nb.dist += e.dist;
                    d[nb.ver][idx] = nb.dist;
                    nb.brtt = idx;
                    q.push(nb);
                }
            }
        }
    }
}


void solve()
{
    dijkstra(1);
    long long ans1=1e18,mint;
    for(int j=1;j<=k;j++)
    {
        if(d[n][j]!=inf)
        {
            if(d[n][j]<ans1)
            {
                ans1 = d[n][j];
                mint = j;
            }
        }
    }
    cout << ans1 << " " << mint << endl;
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    read();
    solve();
    return 0;
}
