#include <iostream>
#include <vector>
#include <queue>
#define endl '\n'
using namespace std;
const int inf = 1000000000 * 1000000 + 1;
struct el
{
    int ver, diff;
};
vector <el> v[1000001];
unsigned long long int used[1000001], used1[1000001];
int n, m, k;
int d[1000001];
void read()
{
    cin >> n >> m >> k;
    int a;
    for(int i = 1; i <= k; i++)cin >> a;
    for(int i = 1; i <= k; i++)cin >> d[i];
    int b, c;
    for(int i = 1; i <= m; i++)
    {
        cin >> a >> b >> c;
        v[a].push_back({b, c});
        v[b].push_back({a, c});
    }
}
void init()
{
    for(int i = 1; i <= n; i++)used[i] = inf;
}
void BFS(int beg)
{
    used[beg] = 0;
    queue <int> q;
    q.push(beg);
    while(!q.empty())
    {
        int c = q.front();
        q.pop();
        used1[c] = 1;
        int sz = v[c].size();
        for(int i = 0; i < sz; i++)
        {
            int nb = v[c][i].ver;
            int diff = used[c] + v[c][i].diff;
            if(diff < used[nb])used[nb] = diff;
            if(!used1[nb])
            {
                q.push(nb);
                used1[nb] = 1;
            }
        }
    }
}
int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    read();
    init();
    BFS(1);
    cout << used[n] << " " << 0 << endl;
    return 0;
}
/*
10 16 16
0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0
5 9 6 4 5 4 3 3 2 3 50 8 15 8 9 1
3 1 1
3 6 2
6 10 3
6 8 4
6 9 5
9 10 6
1 8 7
9 8 8
1 5 9
8 5 10
2 5 11
8 2 12
2 4 13
9 4 14
4 7 15
10 7 1
*/