#include <bits/stdc++.h>
using namespace std;
struct edge
{
    unsigned long long ver, dist;
    edge() {};
    edge(unsigned long long ver2, unsigned long long dist2)
    {
        ver = ver2;
        dist = dist2;
    }
    bool operator <(const edge&t)const
    {
        return dist > t.dist;
    }
};
map<pair<unsigned long long, unsigned long long>, unsigned long long> type;
vector <edge> v[1000005];
unsigned long long n, m, k;
vector <unsigned long long> put[1000005];
unsigned long long c[1000005], t[1000005];
void read()
{
    cin >> n >> m >> k;
    for(unsigned long long i = 1; i <= k; i++)
    {
        cin >> t[i];
    }
    for(unsigned long long i = 1; i <= k; i++)
    {
        cin >> c[i];
    }
    unsigned long long u, v2, t;
    for(unsigned long long i = 1; i <= m; i++)
    {
        cin >> u >> v2 >> t;
        edge ed(u, c[t]);
        v[v2].push_back(ed);
        ed.ver = v2;
        v[u].push_back(ed);
        pair<unsigned long long, unsigned long long> e;
        e.first = u;
        e.second = v2;
        type.insert({e, t});
        e.first = v2;
        e.second = u;
        type.insert({e, t});
    }
}
unsigned long long d[1000005];
unsigned long long used[1000005];
unsigned long long par[1000005];
void dijkstra(unsigned long long s)
{
    memset(d, -1, sizeof(d));
    d[s] = 0;
    edge e(s, 0);
    priority_queue <edge> q;
    q.push(e);
    while(!q.empty())
    {
        e = q.top();
        q.pop();
        if(e.dist <= d[e.ver])
        {
            if(!used[e.ver])
            {
                used[e.ver] = 1;
                for(unsigned long long i = 0; i < v[e.ver].size(); i++)
                {
                    edge nb = v[e.ver][i];
                    pair <unsigned long long, unsigned long long> parrent;
                    parrent.first = par[e.ver];
                    parrent.second = e.ver;
                    pair <unsigned long long, unsigned long long> cur;
                    cur.first = e.ver;
                    cur.second = nb.ver;
                    if(type[parrent] == type[cur])
                    {
                        if(e.dist < d[nb.ver])
                        {
                            par[nb.ver] = e.ver;
                            nb.dist = e.dist;
                            d[nb.ver] = nb.dist;
                            q.push(nb);
                        }
                    }
                    if(e.dist + nb.dist < d[nb.ver])
                    {
                        par[nb.ver] = e.ver;
                        nb.dist += e.dist;
                        d[nb.ver] = nb.dist;
                        q.push(nb);
                    }
                }
            }
        }
    }
    int br = 0;
    int st = n;
    unsigned long long int t;
    t = -1;
    while(st != 0)
    {
        pair <int , int> prev;
        prev.first = par[n];
        prev.second = n;
        if(type[prev] == 1)br++;
        st = par[st];
    }
    if(d[n] == t) cout << -1 << endl;
    else cout << d[n] << " " << 0 << endl;

}
int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    read();
    dijkstra(1);
    return 0;
}
