#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

vector<short> big_multiply(vector<short> num, int multiplier) {
    int next = 0;
    int orig_size = num.size();
    for(int i=0; i<orig_size; i++) {
        num[i] *= multiplier;
        num[i] += next;
        if(num[i] > 9) {
            next = num[i] / 10;
            num[i] %= 10;
        } else next = 0;
    }
    if(next > 0) num.push_back(next);
    return num;
}

int main() {
    cout.sync_with_stdio(false);
    cin.tie(NULL);

    vector<short> num {1};

    unsigned short n;
    cin >> n;

    unsigned int multiplier = 6;
    for(unsigned short i=0;i<n-1;i++) {
        num = big_multiply(num, multiplier);
        multiplier += 9 + 4*i;
    }
    reverse(num.begin(),num.end());
    for(short e : num) {
        cout << e;
    }

    /*
    switch(n) {
        case 1: output = 1; break;
        case 2: output = 6; break;
        case 3: output = 90; break;
        case 4: output = 2520; break;
        case 5: output = 113400; break;
        case 6: output = 1247400; break;
    }
    */
}
/*
6
15 += 9
28 += 9 + 4
45 += 9 + 4 + 4
*/
