#include <bits/stdc++.h>
#define to first
#define line second
using namespace std;

vector<pair<int, int> > edge[100005];
int mindist[100005];
bool type[1000005];
int price[1000005];
int n, m, k;
set <int> brLines;

int calculatePrice(set<int> a)
{
    int br=0;
    for (auto it=a.begin() ; it != a.end() ; it++)
    {
        br += price[*it];
    }
    return br;
}

void algo()
{
    set<int> passedLines;
    priority_queue<pair <int, pair<int, set<int> > > > pq;
    pq.push(make_pair(1, make_pair(0, passedLines)));
    int curr;
    for ( ; pq.size() ; )
    {
        curr=pq.top().first;
        //cout << curr << endl;
        if (curr==n)
        {
            brLines.insert(pq.top().second.first);
            pq.pop();
            continue;
        }
        for (int i=0 ; i<edge[curr].size() ; i++)
        {
            bool IsLineNotPassed;
            auto c = passedLines.find(edge[curr][i].line);
            if (c != passedLines.end()) IsLineNotPassed=false;
            else IsLineNotPassed=true;
            if (IsLineNotPassed+pq.top().second.first < mindist[edge[curr][i].to])
            {
                mindist[edge[curr][i].to]=IsLineNotPassed+pq.top().second.first;
                passedLines=pq.top().second.second;
                passedLines.insert(edge[curr][i].line);
                pq.pop();
                int p = calculatePrice(passedLines);
                pq.push(make_pair(edge[curr][i].to, make_pair(p, passedLines)));
            }

            //cout << "i=" << i << " edge[curr].size()=" << edge[curr].size() << endl;
        }
    }

    int minprice=INT_MAX;
    for (auto it=brLines.begin() ; it != brLines.end() ; it++)
    {
        if (*it<minprice) minprice = *it;
    }
    cout << minprice << " 0\n" << endl;
}


int main()
{
    fill(mindist, mindist+100005, INT_MAX);
    mindist[1]=0;
    cin >> n >> m >> k;
    for (int i=0 ; i<k ; i++) {cin >> type[i];}
    for (int i=0 ; i<k ; i++) {cin >> price[i];}
    int a, b, c;
    for (int i=0 ; i<m ; i++)
    {
        cin >> a >> b >> c;
        edge[b].push_back(make_pair(a, c));
        edge[a].push_back(make_pair(b, c));
    }
    algo();
    return 0;
}

