# include <iostream>
# define endl '\n'
using namespace std;

const int MAX=200001;
long long v[MAX];
long long n,sb=0;

pair<long long, long long> solve(long long t)
{
    long long br=0,left=0,not_used=0;
    for(int i=1; i<=n; i++)
    {
        if(left>=v[i])
        {
            left=left-v[i];
            not_used++;
        }
        else
        {
            //cout<<"!"<<left+t*(not_used+1)<<endl;
            if(left+t*(not_used+1)<v[i])
            {
                return {-1,left};
            }
            else  //!
            {
                long long k=(v[i]-left)/t;
                if((v[i]-left)%t!=0) k++;

                br=br+k;
                not_used=not_used-k+1;
                left=left+k*t-v[i];
            }
        }

        //cout<<br<<" "<<left<<" "<<not_used<<endl;
    }

    return {br,left};
}

long long fastest()
{
    long long l=1,r=1e9,ans=1e9;
    while(l<=r)
    {
        long long mid=(l+r)/2;
        //cout<<l<<" "<<r<<" "<<ans<<endl;
        if(solve(mid).first>-1)
        {
            r=mid-1;
            ans=min(ans,mid);
        }
        else l=mid+1;
    }

    return ans;
}

int main()
{
    cin>>n;

    for(int i=1; i<=n; i++)
    {
        cin>>v[i];
        sb=sb+v[i];
    }

    long long k=fastest();
    cout<<solve(k).first<<" "<<solve(k).second<<endl;

    for(int i=1;i<=100;i++)
    {
        cout<<i<<" "<<solve(i).first<<" "<<solve(i).second<<endl;
    }

    long long q;
    cin>>q;

    for(int i=1;i<=q;i++)
    {
        long long t;
        cin>>t;

        if(t<k) cout<<-1<<endl;
        else if(t>=sb) cout<<1<<endl;
        else
        {
            cout<<solve(t).first<<endl;
        }
    }
    return 0;
}

