#include <iostream>
#include <vector>
#include <string>
#include <cstring>
#include <algorithm>

using namespace std;

int n;

void fastIO()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
}

int main()
{
    fastIO();

    cin >> n;

    vector<char> let(2 * n);

    for (int i = 0; i < n; ++i)
    {
        let[i] = char(i + 'A');
    }

    for (int i = n; i < 2 * n; ++i)
    {
        let[i] = char((i - n) + 'a');
    }

    vector<int> p;

    for (int i = 0; i < 2 * n; ++i)
    {
        p.push_back(i);
    }

    int ans = 0;

    do
    {
        vector<bool> cnt(26, 0);

        bool fl = 1;

        for (int i = 0; i < p.size(); ++i)
        {
            if (let[p[i]] >= 'a' & let[p[i]] <= 'z')
            {
                if (cnt[(let[p[i]] - 'a')] == 0)
                {
                    fl = 0;
                    break;
                }
            }
            else
            {
                cnt[(let[p[i]] - 'A')] = 1;
            }
        }

        ans += fl;

    } while (next_permutation(p.begin(), p.end()));

    cout << ans << endl;

    return 0;
}
