#include <iostream>
#include <string>

using namespace std;

int n;

string mult(const string& a, int b)
{
    string c;

    int carry = 0;

    for (int i = 0; i < a.size() || carry; ++i)
    {
        int curr = carry;

        if (i < a.size())
        {
            curr += (a[i] - '0') * b;
        }

        c.push_back(char(curr % 10 + '0'));

        carry = curr / 10;
    }

    return c;
}

void fastIO()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
}

int main()
{
    //fastIO();

    cin >> n;

    string ans = "1";

    for (int i = 2 * n; i >= 2; i -= 2)
    {
        long long curr = (i * (i - 1)) / 2;
        ans = mult(ans, curr);
    }

    for (int i = ans.size() - 1; i >= 0; --i)
    {
        cout << ans[i];
    }

    cout << endl;

    return 0;
}
