#include <iostream>

using namespace std;

const int maxn = 200005;

int n;

long long a[maxn];

void solve()
{
    long long t;
    cin >> t;

    int ans = 0;
    long long from_prv = 0;

    for (int i = 1; i <= n; ++i)
    {
        if (a[i] - from_prv > 0)
        {
            ++ans;

            if (a[i] - from_prv > t)
            {
                cout << -1 << "\n";
                return;
            }

            from_prv = t - (a[i] - from_prv);
        }
        else
        {
            from_prv -= a[i];
        }
    }

    cout << ans << "\n";
}

void fastIO()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
}

int main()
{
    fastIO();

    cin >> n;

    for (int i = 1; i <= n; ++i)
    {
        cin >> a[i];
    }

    int q;
    cin >> q;

    while (q--)
    {
        solve();
    }

    return 0;
}
