#include <iostream>

using namespace std;

const int maxn = 200005;

int n;

long long a[maxn];

long long p[maxn];
long long s[maxn];

void solve()
{
    long long t;
    cin >> t;

    if (t < a[1])
    {
        cout << -1 << "\n";
        return;
    }

    int l = 1;
    int r = n;

    while (l <= r)
    {
        int mid = (l + r) / 2;

        if (mid * t - p[mid] >= s[mid + 1])
        {
            r = mid - 1;
        }
        else
        {
            l = mid + 1;
        }
    }

    cout << l << "\n";
}

void fastIO()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
}

int main()
{
    fastIO();

    cin >> n;

    for (int i = 1; i <= n; ++i)
    {
        cin >> a[i];

        p[i] = p[i - 1] + a[i];
    }

    for (int i = n; i >= 1; --i)
    {
        s[i] = s[i + 1] + a[i];
    }

    int q;
    cin >> q;

    while (q--)
    {
        solve();
    }

    return 0;
}
