#include <bits/stdc++.h>
using namespace std;
typedef unsigned long long ull;
string sub1(string a){
    char last = a[a.size()-1];
    if(last != '0'){
        a[a.size()-1]--;
    }else{
        a[a.size()-1] = '9';
        int carry = 1;
        for(int i = a.size()-2; i >= 0; i--){
            int curr = a[i] - '0';
            curr -= carry;
            carry = 0;
            while(curr < 0){
                curr += 10;
                carry++;
            }
            a[i] = curr + '0';
        }
        cout << carry << '\n';
    }
    int idx = 0;
    while(a[idx] == '0'){ idx++; }
    if(idx == a.length()){ return "0"; }
    return a.substr(idx);
}

string itos(int n){
    if(n == 0){return "0";}
    string s = "";
    while(n != 0){
        s += n%10 + '0';
        n/=10;
    }
    reverse(s.begin(), s.end());
    return s;
}

string add(string a, string b){
    if(a.size() < b.size()){ swap(a, b); }
    while(b.size() < a.size()){
        b = '0' + b;
    }

    int carry = 0;
    for(int i = a.size()-1; i >= 0; i--){
        int cA = a[i] - '0';
        int cB = b[i] - '0';
        int sum = cA + cB + carry;
        carry = 0;
        while(sum > 9){
            sum -= 10;
            carry++;
        }
        a[i] = sum + '0';
    }

    string carrys = "";
    if(carry != 0){
        carrys = itos(carry);
    }
    return carrys + a;
}

string mul(string a, int b){ /// digit b
    int carry = 0;
    for(int i = a.size()-1; i >= 0; i--){
        int c = a[i] - '0';
        c *= b;
        c += carry;
        carry = 0;
        while(c > 9){
            c -= 10;
            carry++;
        }
        a[i] = c + '0';
    }
    string carrys = "";
    if(carry != 0){
        carrys = itos(carry);
    }
    return carrys + a;
}

string shift(string a, int i){
    for(int j = 0; j < i; j++){
        a += '0';
    }
    return a;
}

string mul(string a, string b){
    string res = "0";
    int iter = 0;
    for(int i = b.size()-1; i >= 0; i--){
        int dig = b[i] - '0';
        string ml = mul(a, dig);
        string shft = shift(ml, iter);
        res = add(res, shft);
        iter++;
    }
    return res;
}

string g(int n){
    if(n == 1){return "1";}
    string lastG = g(n-1);
    return add(lastG, itos(n));
}

string f(int n){
    if(n == 1){ return "1"; }
    string lastF = f(n-1);
    string lastG = g((n-1) * 2 + 1);
    return mul(lastF, lastG);
}

int main(){
    /// todo - dulgi chisla;

//    string a = "123";
//    string b = "456";
//    cout << mul(a, b) << '\n';

    int n;
    cin >> n;

    cout << f(n) << '\n';

    return 0;
}
