#include <bits/stdc++.h>
using namespace std;
typedef signed long long ull;
typedef pair<ull, ull> pii;
const ull MAXN = 200007;
const ull MNOGO = LLONG_MAX;
ull n;
vector<ull> v(n);
ull t;
struct DP{
    ull tubes;
    ull overflow;
    bool lastOpen;
};
DP dp[MAXN];

DP f(ull idx){
    if(idx == 0){return dp[idx] = {0, 0, 0};}
    if(dp[idx].tubes != -7){
        return dp[idx];
    }

    DP prev = f(idx-1);
    if(prev.tubes == -1){ return dp[idx] = {-1, -2, false}; }

    if(prev.overflow >= v[idx]){
        prev.overflow -= v[idx];
        return dp[idx] = prev;
    }
    ull level = prev.overflow;
    /// backtrack?
    while(level < v[idx]){
//        cout << "idx: " << idx << ", lvl: " << level << "/" << v[idx] << '\n';
        if(prev.tubes >= idx){
            level += t;
            if(level >= v[idx]){
                ull overflow = level-v[idx];
                return dp[idx] =  {prev.tubes+1, overflow, true};
            }
             return dp[idx] = {-1, -2, false};
        }
        prev.tubes ++;
        level += t;
    }
    if(level > v[idx]){
        prev.overflow = level - v[idx];
    }
    return dp[idx] = prev;
}
ull solve(){
    if(v[1] > t){return -1;}
    for(int i = 0; i <= n; i++){
        dp[i] = {-7,-7,false};
    }
    DP res = f(n);
//    cout << res.first << ' ' << res.second << '\n';
    return res.tubes;
}

int main(){
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    cin >> n;
    v.resize(n+1);
    for(ull i = 1; i <= n; i++){ cin >> v[i]; }
    ull q;
    cin >> q;

    for(ull i = 1; i <= q; i++){
        cin >> t;
        cout << solve() << '\n';
    }

    return 0;
}
