#include <bits/stdc++.h>
using namespace std;
typedef unsigned long long ull;
const int MAXK = 1000007;
const int MAXN = 100007;
const int MNOGO = 1e7;

int n, m, k;
bool lineTypes[MAXK];
int prices[MAXK];
unordered_set<int> L[MAXK]; /// graph: liniq <-> liniq
unordered_set<int> lines[MAXN];

bool visited[MAXK];
int prv[MAXK];
unsigned int dist[MAXK];
int dijkstra(int start, int target){
    priority_queue<pair<int, pair<int, int>>> q;
    q.push({-0, {start, -1}});
    while(!q.empty()){
//        cout << q.size() << '\n';
        int currDist = -q.top().first;
        int curr = q.top().second.first;
        int from = q.top().second.second;
        q.pop();
//        cout << "pop " << curr+1 << '\n';
        visited[curr] = true;
        prv[curr] = from;
        for(unordered_set<int>::iterator it = L[curr].begin(); it != L[curr].end(); ++it){
            int next = *it;
            if(visited[next] == true){ continue; }
            if(dist[next] > dist[curr] + prices[next]){
                dist[next] >= dist[curr] + prices[next];
                q.push({-(currDist + 1), {next, curr}});
//                cout << "\tpush " << currDist+1 << ' ' << next+1 << ' ' << curr+1 << '\n';
            }
        }
    }
//    cout << "vis(" << target << ") =  " << visited[target] << '\n';
    return dist[target];
}
int main(){
//    ios_base::sync_with_stdio(false);
//    cin.tie(nullptr);
//    cout.tie(nullptr);

    cin >> n >> m >> k;
    for(int i = 0; i < k; i++){
        cin >> lineTypes[i];
    }
    for(int i = 0; i < k; i++){
        cin >> prices[i];
    }

    for(int i = 0; i < m; i++){
        int u, v, t;
        cin >> u >> v >> t;
        u--; v--; t--;
        for(unordered_set<int>::iterator it = lines[u].begin(); it != lines[u].end(); ++it){
            if(*it != t){
                L[t].insert(*it);
                L[*it].insert(t);
//                cout << "connected " << t+1 << " with " << *it+1 << '\n';
            }
        }
        for(unordered_set<int>::iterator it = lines[v].begin(); it != lines[v].end(); ++it){
            if(*it != t){
                L[t].insert(*it);
                L[*it].insert(t);
//                cout << "connected " << t+1 << " with " << *it+1 << '\n';
            }
        }
        lines[u].insert(t);
        lines[v].insert(t);
    }

    int mn = INT_MAX;
    for(unordered_set<int>::iterator it1 = lines[0].begin(); it1 != lines[0].end(); ++it1){
        int from = *it1;
        for(unordered_set<int>::iterator it2 = lines[n-1].begin(); it2 != lines[n-1].end(); ++it2){
            memset(visited, 0, sizeof(visited));
            memset(dist, (unsigned int)-1, sizeof(dist));
            int to = *it2;
            int dst = dijkstra(from, to);
//            cout << from+1 << " -> " << to+1 << '\n';
//            cout << "\tdst: " << dst << '\n';
            int sum = 0;
            for(int i = to; i != -1; i=prv[i]){
//                cout << '\t' << i+1 << '\n';
                sum += prices[i];
            }
//            cout << "\tprice = " << sum << '\n';
//            return 0;
            if(sum < mn){
                mn = sum;
            }
        }
    }
    cout << mn << '\n';

    return 0;
}
