#include <bits/stdc++.h>
using namespace std;

const long long MAX_N=2*1e5+1;
long long N, Q;
long long v[MAX_N];

bool is_good(const long long& value, long long& t)
{
    long long x=1;
    long long counter=0;
    long long sum=0;

    for(long long i=1; i<=N; i++)
    {
        sum+=v[i];

        while(x<i && sum>x*t)
        {
            x++;

            if(x>value)
            {
                return false;
            }
        }

        if(sum>x*t)
        {
            return false;
        }
    }

    return true;
}

long long bs(long long& t)
{
    long long l=1, r=N;
    long long ans=-1;

    while(l<=r)
    {
        long long m=(l+r)/2;

        if(is_good(m, t))
        {
            ans=m;
            r=m-1;
        }
        else
        {
            l=m+1;
        }
    }

    return ans;
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    cin >> N;

    for(long long i=1; i<=N; i++)
    {
        cin >> v[i];
    }

    cin >> Q;

    while(Q--)
    {
        long long t;
        cin >> t;

        if(t<v[0])
        {
            cout << -1 << '\n';
        }
        else
        {
            cout << bs(t) << '\n';
        }
    }

    return 0;
}

