#include <bits/stdc++.h>
using namespace std;

const long long MAX_N=2*1e5+1;
long long N, Q;
long long v[MAX_N];

bool is_good(const long long& value, long long& t)
{
    long long x=1;
    long long counter=0;
    long long sum=0;

    if(t*value<sum)
    {
        return false;
    }

    for(long long i=1; i<=N; i++)
    {
        sum+=v[i];

        while(x<i && sum>x*t)
        {
            x++;

            if(x>value)
            {
                return false;
            }
        }

        if(sum>x*t)
        {
            return false;
        }
    }

    return true;
}

long long bs(long long& t)
{
    long long l=1, r=N;
    long long ans=-1;
    long long m;

    while(l<=r)
    {
        m=(l+r)/2;

        if(is_good(m, t))
        {
            ans=m;
            r=m-1;
        }
        else
        {
            l=m+1;
        }
    }

    return ans;
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    cin >> N;

    long long sum=0;

    for(long long i=1; i<=N; i++)
    {
        cin >> v[i];
        sum+=v[i];
    }

    cin >> Q;

    long long t;

    while(Q--)
    {
        cin >> t;

        long long value=sum/t;

        if(value>N)
        {
            cout << -1 << '\n';
        }
        else
        {
            bool haha=false;

            for(value; value<=N; value++)
            {
                if(is_good(value, t))
                {
                    haha=true;
                    cout << value << '\n';
                    break;
                }
            }

            if(!haha)
            {
                cout << -1 << '\n';
            }
        }
    }

    return 0;
}
