#include <bits/stdc++.h>
using namespace std;

const int MAX_N=1e5+1, MAX_M=1e6+1, MAX_K=1e6+1;
const long long INF=1e18;
int N, M, K;
int type[MAX_K];
int price[MAX_K];
int is_bought[MAX_K];
vector<pair<int, int>> edges[MAX_M];
pair<long long, int> dist[MAX_N];

void dfs(int u)
{
    for(auto& v:edges[u])
    {
        long long p=dist[u].first, tram=dist[u].second;

        if(is_bought[v.second]==0)
        {
            p+=price[v.second];
            tram+=type[v.second];
        }

        is_bought[v.second]++;

        if(dist[v.first].first>p || dist[v.first].first==p && dist[v.first].second>tram)
        {
            ///cout << v.first << " -> " << p << " " << tram << '\n';
            dist[v.first]={p, tram};
            dfs(v.first);
        }

        is_bought[v.second]--;
    }
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    cin >> N >> M >> K;

    for(int i=1; i<=K; i++)
    {
        cin >> type[i];
    }

    for(int i=1; i<=K; i++)
    {
        cin >> price[i];
    }

    for(int i=1; i<=M; i++)
    {
        int u, v, t;
        cin >> u >> v >> t;
        edges[u].push_back({v, t});
        edges[v].push_back({u, t});
    }

    for(int i=1; i<=N; i++)
    {
        dist[i].first=INF;
    }

    dist[1]={0, 0};
    dfs(1);

    cout << dist[N].first << " " << dist[N].second << '\n';
    return 0;
}

