#include <bits/stdc++.h>
using namespace std;

const int MAX_N=1e5+1, MAX_M=1e6+1, MAX_K=1e6+1;
const long long INF=1e18;
int N, M, K;
int type[MAX_K];
int price[MAX_K];
vector<pair<int, int>> edges[MAX_M];
long long dist[MAX_N];
bool is_bought[MAX_K];

void dfs(int u)
{
    for(auto& v:edges[u])
    {
        long long p=dist[u];
        int currently=0;

        if(!is_bought[v.second])
        {
            p+=price[v.second];
            is_bought[v.second]=true;
            currently++;
        }

        if(dist[v.first]>p)
        {
            dist[v.first]=p;
            dfs(v.first);
        }

        if(currently==1)
        {
            is_bought[v.second]=false;
        }
    }
}


int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    cin >> N >> M >> K;

    for(int i=1; i<=K; i++)
    {
        cin >> type[i];
    }

    for(int i=1; i<=K; i++)
    {
        cin >> price[i];
    }

    for(int i=1; i<=M; i++)
    {
        int u, v, t;
        cin >> u >> v >> t;
        edges[u].push_back({v, t});
        edges[v].push_back({u, t});
    }

    for(int i=1; i<=N; i++)
    {
        dist[i]=INF;
    }

    dist[1]=0;
    dfs(1);
    cout << dist[N] << " " << 0;
    return 0;
}
