#include <bits/stdc++.h>
#define endl '\n'

using namespace std;

const int maxn = 64;
long long comb[maxn][maxn], dp[maxn][maxn], fact[maxn];

void pascal(){
    for(int i = 0;i < maxn;i++)
        comb[i][0] = 1;
    for(int i = 1;i < maxn;i++)
        for(int j = 1;j < maxn;j++)
            comb[i][j] = comb[i - 1][j - 1] + comb[i - 1][j];
    fact[0] = 1;
    for(int i = 1;i < maxn;i++)
        fact[i] = fact[i - 1] * i;
}

void solve(int n){
    dp[1][1] = 1;
    dp[1][0] = 1;
    for(int i = 2;i <= n;i++){
        for(int j = 0;j <= i;j++){
            for(int k = 0;k <= j;k++){
                dp[i][j] += comb[i][k] * dp[i - 1][j - k];
            }

        }
    }
    long long ans = dp[n][n] * fact[n];
    cout << ans << endl;
}
int main(){
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    pascal();
    int n;
    cin >> n;
    solve(n);
    return 0;
}
