#include <bits/stdc++.h>
#define endl '\n'

using namespace std;

const int maxn = 1e5 + 10;
int n, m, k, type[maxn], c[maxn], u[maxn], v[maxn], t[maxn];

struct edge{
    int x, dist;

    bool operator<(const edge &e) const{
        return dist > e.dist;
    }
};
vector<edge> g[maxn];
long long used[maxn], dp[maxn];
long long ans = 1e17, tr;

void read(){
    cin >> n >> m >> k;
    for(int i = 1;i <= k;i++){
        cin >> type[i];
    }
    for(int i = 1;i <= k;i++){
        cin >> c[i];
    }
    for(int i = 1;i <= m;i++){
        cin >> u[i] >> v[i] >> t[i];
        g[u[i]].push_back({v[i], t[i]});
        g[v[i]].push_back({u[i], t[i]});
    }
}

void dfs(int ver){
    used[ver] = 1;
    for(edge nb : g[ver]){
        if(!used[nb.x]){
            dfs(nb.x);
        }
        dp[nb.x] = min(dp[nb.x], dp[ver] + nb.dist);
    }
}

int main(){
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    read();
    for(int i = 2;i <= n;i++)
        dp[i] = 1e17;
    dfs(1);
    cout << dp[n] << " " << 0 << endl;
    return 0;
}
