#include <bits/stdc++.h>
#define endl '\n'

using namespace std;

const int maxn = 1e6 + 10;
int n, m, k, type[maxn], c[maxn], u[maxn], v[maxn], t;

struct edge{
    int x, dist, t;

    bool operator<(const edge &e) const{
        return dist > e.dist;
    }
};
vector<edge> g[maxn];
vector< int > p[maxn];
int used[maxn], tr[maxn];

void read(){
    cin >> n >> m >> k;
    for(int i = 1;i <= k;i++){
        cin >> type[i];
    }
    for(int i = 1;i <= k;i++){
        cin >> c[i];
    }
    for(int i = 1;i <= m;i++){
        cin >> u[i] >> v[i] >> t;
        p[t].push_back(v[i]);
        p[t].push_back(u[i]);
    }
    for(int i = 1;i <= k;i++){
        sort(p[i].begin(), p[i].end());
        vector<int> w;
        w.push_back(p[i][0]);
        for(int j = 1;j < p[i].size();j++){
            if(p[i][j] != p[i][j - 1])
                w.push_back(p[i][j]);
        }
        for(int j = 0;j < w.size();j++){
            for(int k = 0;k < w.size();k++){
                if(w[k] != w[j]){
                    g[w[k]].push_back({w[j], c[i], type[i]});
                }
            }
        }
        p[i] = w;
    }
}


void bfs(int ver){
    used[ver] = 1;
    tr[ver] = 0;
    queue<int> q;
    q.push(ver);
    while(!q.empty()){
        int t = q.front();
        q.pop();
        for(edge nb : g[t]){
            if(!used[nb.x]){
                used[nb.x] = used[t] + nb.dist;
                tr[nb.x] = tr[t] + nb.t;
                q.push(nb.x);
            }
            else{
                if(used[nb.x] > used[t] + nb.dist || (used[nb.x] == used[t] + nb.dist && tr[nb.x] > tr[t] + nb.t)){
                    used[nb.x] = used[t] + nb.dist;
                    tr[nb.x] = tr[t] + nb.t;
                    q.push(nb.x);
                }
            }
        }
    }
    cout << used[n] - 1 << " " << tr[n] << endl;
}

int main(){
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    read();
    bfs(1);
    return 0;
}
