#include <bits/stdc++.h>

using namespace std;

struct edge
{
    int ver,dist,num;
    edge(){};
    edge(int vi, int di, int ni)
    {
        ver = vi;
        dist = di;
        num = ni;
    }
    bool operator<(const edge&ed) const
    {
        return dist>ed.dist;
    }
};

const int maxn = 1e6+5;

int n,m,k;
int t[maxn],c[maxn];
long long dp[maxn];
long long minpaths[maxn];
//int mat[maxn][maxn];
//unsigned long long d[maxn],inf=-1;
//int last[maxn];
vector<edge>v[maxn];
vector<int>pom[maxn],sp[maxn];
int used[maxn],usedk[maxn];
vector<int>paths;

void read()
{
    cin >> n >> m >> k;
    for(int i=1;i<=k;i++) cin >> t[i];
    for(int i=1;i<=k;i++) cin >> c[i];
    int x,y,z;
    for(int i=1;i<=m;i++)
    {
        cin >> x >> y >> z;
        pom[z].push_back(x);
        pom[z].push_back(y);
        v[x].push_back({y,c[z],z});
        v[y].push_back({x,c[z],z});
    }
    int nb;
    for(int i=1;i<=k;i++)
    {
        sort(pom[i].begin(),pom[i].end());
        for(int j=0;j<pom[i].size();j++)
        {
            nb = pom[i][j];
            if(sp[i].size()==0||sp[i].back()!=nb)
            {
                sp[i].push_back(nb);
            }
        }
    }
    /*for(int i=1;i<=k;i++)
    {
        for(int j=1;j<=n;j++)
        {
            if(mat[i][j]) pom[i].push_back(j);
        }
    }
    int sz,ch1,ch2;
    for(int i=1;i<=k;i++)
    {
        sz = pom[i].size();
        for(int j=0;j<sz;j++)
        {
            for(int j2=j+1;j2<sz;j2++)
            {
                ch1 = pom[i][j];
                ch2 = pom[i][j2];
                v[ch1].push_back({ch2,c[i]});
                v[ch2].push_back({ch1,c[i]});
            }
        }
    }*/
}

void BFS(int beg)
{
    used[beg] = 1;
    queue<edge>q;
    q.push({1,0,0});
    edge w,nb;
    int sz;
    while(!q.empty())
    {
        w = q.front();
        q.pop();
        sz = v[w.ver].size();
        for(int i=0;i<sz;i++)
        {
            nb = v[w.ver][i];
            if(!used[nb.ver])
            {
                usedk[nb.num]++;
            if(usedk[nb.num]==1) paths.push_back(nb.num);
                used[nb.ver] = used[w.ver] + 1;
                q.push(nb);
            }
        }
    }
}

/*void dijkstra(int beg)
{
    memset(d,-1,sizeof(d));
    priority_queue<edge>q;
    d[beg] = 0;
    last[beg] = 0;
    q.push({beg,0,0});
    int sz;
    edge e,nb;
    while(!q.empty())
    {
        e = q.top();
        q.pop();
        if(e.dist<=d[e.ver])
        {
            sz = v[e.ver].size();
            for(int i=0;i<sz;i++)
            {
                nb = v[e.ver][i];
                if(nb.num==last[e.ver]) nb.dist = 0;
                if(e.dist+nb.dist<d[nb.ver])
                {
                    nb.dist += e.dist;
                    d[nb.ver] = nb.dist;
                    last[nb.ver] = nb.num;
                    q.push(nb);
                }
            }
        }
    }
}*/

void dfs(int beg)
{
    used[beg] = 1;
    int sz = v[beg].size();
    edge nb;
    for(int i=0;i<sz;i++)
    {
        nb = v[beg][i];
        usedk[nb.num]++;
        if(usedk[nb.num]==1) paths.push_back(nb.num);
        if(!used[nb.ver])
        {
            dfs(nb.ver);
        }
    }
}

void solve()
{
    BFS(1);
    memset(dp,-1,sizeof(dp));
    dp[1] = 0;
    minpaths[1] = 0;
    int idx,sz,nb;
    for(int nz=1;nz<=10;nz++)
    {
    for(int i=0;i<paths.size();i++)
    {
        idx = paths[i];
        //cout << "+++++++++" << " " << idx << endl;
        sz = sp[idx].size();
        long long mindp = 1e18;
        long long minp = 1e18;
        for(int j=0;j<sz;j++)
        {
            nb = sp[idx][j];
            if(dp[nb]!=-1)
            {
                if(dp[nb]<mindp)
                {
                    mindp = dp[nb];
                    minp = minpaths[nb];
                }
            }
        }
        mindp += c[idx];
        minp++;
        for(int j=0;j<sz;j++)
        {
            nb = sp[idx][j];
            if(dp[nb]==-1)
            {
                dp[nb] = mindp;
                minpaths[nb] = minp;
            }
            else
            {
                if(mindp<dp[nb])
                {
                    dp[nb] = mindp;
                    minpaths[nb] = minp;
                }
            }
        }
        /*cout << idx << endl;
        for(int i=1;i<=n;i++)
        {
            cout << dp[i] << " ";
        }
        cout << endl;*/
    }
}
    cout << dp[n] << " " << 0 << endl;
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    read();
    solve();
    return 0;
}
