#include <bits/stdc++.h>
using namespace std;
struct edge
{
    int ver, dist;
    edge() {};
    edge(int ver2, int dist2)
    {
        ver = ver2;
        dist = dist2;
    }
    bool operator <(const edge&t)const
    {
        return dist > t.dist;
    }
};
map<pair<int, int>, int> type;
vector <edge> v[100005];
int n, m, k;
vector <int> put[1000005];
int c[1000005], t[1000005];
void read()
{
    cin >> n >> m >> k;
    for(int i = 1; i <= k; i++)
    {
        cin >> t[i];
    }
    for(int i = 1; i <= k; i++)
    {
        cin >> c[i];
    }
    int u, v2, t;
    for(int i = 1; i <= m; i++)
    {
        cin >> u >> v2 >> t;
        edge ed(u, c[t]);
        v[v2].push_back(ed);
        ed.ver = v2;
        v[u].push_back(ed);
        pair<int, int> e;
        e.first = u;
        e.second = v2;
        type.insert({e, t});
        e.first = v2;
        e.second = u;
        type.insert({e, t});
    }
}
unsigned long long d[1000005];
int used[1000005];
int par[1000005];
void dijkstra(int s)
{
    memset(d, -1, sizeof(d));
    d[s] = 0;
    edge e(s, 0);
    priority_queue <edge> q;
    q.push(e);
    while(!q.empty())
    {
        e = q.top();
        q.pop();
        if(e.dist <= d[e.ver])
        {
            if(!used[e.ver])
            {
                used[e.ver] = 1;
                for(int i = 0; i < v[e.ver].size(); i++)
                {
                    edge nb = v[e.ver][i];
                    pair <int, int> parrent;
                    parrent.first = par[e.ver];
                    parrent.second = e.ver;
                    pair <int, int> cur;
                    cur.first = e.ver;
                    cur.second = nb.ver;
                    if(type[parrent] == type[cur])
                    {
                        if(e.dist < d[nb.ver])
                        {
                            par[nb.ver] = e.ver;
                            nb.dist = e.dist;
                            d[nb.ver] = nb.dist;
                            q.push(nb);
                        }
                    }
                    if(e.dist + nb.dist < d[nb.ver])
                    {
                        par[nb.ver] = e.ver;
                        nb.dist += e.dist;
                        d[nb.ver] = nb.dist;
                        q.push(nb);
                    }
                }
            }
        }
    }
    cout << d[n] << " " << 0 << endl;
}
int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    read();
    dijkstra(1);
    return 0;
}
